﻿using IgniteUI.Blazor.Controls;
using Microsoft.AspNetCore.Components;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace GridProblem.Pages {
    public partial class Index {
        [Inject]
        public IIgniteUIBlazor IgniteUIBlazor { get; set; }
        [Inject]
        public NavigationManager NavMan { get; set; }

        [Parameter]
        public int ID { get; set; }

        private class Summary {
            public Summary(MeterData data) { 
                Meter = data.Meter; 
                ReadingDate = data.ReadingDate; 
                Header = true; 
                MeterData = data; 
            }
            public Summary(MeterData meterData, Reading data) {
                MeterData = meterData;
                Meter = "";
                ReadingDate = meterData.ReadingDate;
                Header = false;
                ReadingData = data;
                Rate = data.Rate;
                PreviousReading = data.PreviousReading;
                PreviousEstimated = data.PreviousEstimate ? "E" : "";
                //CurrentReading = data.CurrentReading;
                //Estimate = data.CurrentEstimate;
                //Wrap = data.Wrap;
            }
            public bool Header { get; set; }
            public MeterData MeterData { get; set; }
            public Reading ReadingData { get; set; }
            public string Meter { get; set; }
            public string Rate { get; set; }
            public int? PreviousReading { get; set; }
            public string PreviousEstimated { get; set; }
            public DateTime? ReadingDate { get; set; }
            public int? CurrentReading { get; set; }
            public bool Estimate { get; set; }
            public bool Wrap { get; set; }

        }

        private IList<Summary> Data { get; set; } = new List<Summary>();


        protected override void OnInitialized() {
            DataGridModule.Register(IgniteUIBlazor);

            var data = new List<MeterData>() { 
                new MeterData() { 
                    Meter = "M0001", ReadingDate = DateTime.Today,
                    Readings = new List<Reading>() {
                        new Reading() {Rate="Test", PreviousReading=12345, PreviousEstimate=false}
                    }
                } 
            };
            foreach (var mdata in data) {
                Data.Add(new Summary(mdata));
                mdata.Readings.ForEach(r => Data.Add(new Summary(mdata, r)));
            }

        }



    }
}